> ## Documentation Index
> Fetch the complete documentation index at: https://docs.devin.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# List Hypervisors

## Permissions

Requires a service user with the `ViewEnterpriseInfraDetails` permission at the enterprise level.


## OpenAPI

````yaml /v3-openapi.yaml GET /v3/enterprise/hypervisors
openapi: 3.1.0
info:
  description: Devin v3 API with Service User authentication and RBAC
  title: Devin API v3
  version: 3.0.0
servers: []
security:
  - bearerAuth: []
paths:
  /v3/enterprise/hypervisors:
    get:
      summary: List Hypervisors
      operationId: handle_get_hypervisors_v3_enterprise_hypervisors_get
      parameters:
        - in: query
          name: after
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: After
        - in: query
          name: first
          required: false
          schema:
            default: 100
            maximum: 200
            minimum: 1
            title: First
            type: integer
        - in: query
          name: status
          required: false
          schema:
            default: available
            enum:
              - available
              - restarting
              - disconnected
              - terminated
              - draining
              - all
            title: Status
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedResponse_HypervisorResponse_'
          description: Successful Response
        '422':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
          description: Validation Error
components:
  schemas:
    PaginatedResponse_HypervisorResponse_:
      properties:
        end_cursor:
          anyOf:
            - type: string
            - type: 'null'
          description: Cursor to fetch the next page, or None if this is the last page.
          title: End Cursor
        has_next_page:
          default: false
          description: Whether there are more items available after this page.
          title: Has Next Page
          type: boolean
        items:
          items:
            $ref: '#/components/schemas/HypervisorResponse'
          title: Items
          type: array
        total:
          anyOf:
            - type: integer
            - type: 'null'
          description: Optional total count (can be omitted for performance).
          title: Total
      required:
        - items
      title: PaginatedResponse[HypervisorResponse]
      type: object
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          title: Detail
          type: array
      title: HTTPValidationError
      type: object
    HypervisorResponse:
      properties:
        cloud_provider_instance_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Cloud Provider Instance Id
        created_at:
          anyOf:
            - type: integer
            - type: 'null'
          title: Created At
        hypervisor_id:
          title: Hypervisor Id
          type: string
        last_heartbeat:
          anyOf:
            - type: integer
            - type: 'null'
          title: Last Heartbeat
        status:
          title: Status
          type: string
        utilization_percentage:
          title: Utilization Percentage
          type: number
      required:
        - hypervisor_id
        - status
        - utilization_percentage
        - created_at
        - last_heartbeat
        - cloud_provider_instance_id
      title: HypervisorResponse
      type: object
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          title: Location
          type: array
        msg:
          title: Message
          type: string
        type:
          title: Error Type
          type: string
      required:
        - loc
        - msg
        - type
      title: ValidationError
      type: object
  securitySchemes:
    bearerAuth:
      description: 'Service User credential (prefix: cog_)'
      scheme: bearer
      type: http

````